@echo off & setlocal enableextensions
echo Ŀ
echo  WHEREIS.CMD, A script to locate files 
echo  By Prof. Timo Salmi Wed 29-Sep-2004   
echo 

:: Is help needed
if not [%1]==[] if not [%1]==[/?] goto _testlfn
echo.
echo Usage: %~n0 [FileMask] [/a] [/m] [/s]
echo.
echo  /a show All files, including hidden
echo  /m pipe to More
echo  /s Sort by date
echo.
echo E.g. %~n0 *.XLS /s /m
if not defined cmdbox if defined PauseIfFromDesktop pause
goto :EOF

:_testlfn
:: Test for LFN peculiarities
if /i not [%2]==[/a] if /i not [%2]==[/m] if /i not [%2]==[/s] if not [%2]==[] (
  echo A file name with spaces in it should be enclosed in parentheses ""
  goto :EOF)

:: Allow an alternative temp directory
if [%MYTEMP%]==[] set MYTEMP=%TEMP%

:: Don't automatically accept a *.* mask
:_temp
if not [%1]==[*.*] goto _browse
echo.
echo Using *.* as the FileMask will produce a HUGE AMOUNT of output!
echo.
set /p ask_=Are you absolutely sure you want to do this [y/N]?
if /i not "%ask_%"=="y" if /i not "%ask_%"=="yes" goto :EOF

:: Next step
:_browse
:: Not a necessary, but prudent habit
set ask_=

:: Allow for the possibility of including also the hidden files
for %%v in (hidden_ sort_ more_) do set %%v=
if /i [%2]==[/a] set hidden_=/a
if /i [%3]==[/a] set hidden_=/a
if /i [%4]==[/a] set hidden_=/a

:: Remove any old auxiliary output file
for %%f in (%MYTEMP%\whereis.$$$) do if exist %%f del %%f

:: Go and find the files, call the subroutine for each of them
for /f "tokens=1 delims=" %%c in ('dir /s /b %hidden_% C:\%1') do (
  call :ProcOnefile "%%c")

:: Choose display format
if not exist %MYTEMP%\whereis.$$$ goto :EOF
if /i [%2]==[/s] set sort_=true
if /i [%3]==[/s] set sort_=true
if /i [%4]==[/s] set sort_=true
if /i [%2]==[/m] set more_=true
if /i [%3]==[/m] set more_=true
if /i [%4]==[/m] set more_=true
if /i [%sort_%]==[true] (
  if /i [%more_%]==[true] (
    type %MYTEMP%\whereis.$$$ | sort | more
    ) else (
    type %MYTEMP%\whereis.$$$ | sort
    )
  ) else (
  if /i [%more_%]==[true] (
    type %MYTEMP%\whereis.$$$ | more
    ) else (
    type %MYTEMP%\whereis.$$$
    )
  )

:: Clean up
:_clean
for %%f in (%MYTEMP%\whereis.$$$) do if exist %%f del %%f
endlocal & goto :EOF

::==================================================================
:ProcOnefile arg1
setlocal enableextensions
  set fullname_=%~f1
  set date_=%~t1
  set time_=%date_:~11,5%
  set date_=%date_:~6,4%.%date_:~3,2%.%date_:~0,2%
  set attr_=%~a1
  set size_=%~z1
  call :FuncRightJustify %size_% rightJustifiedSize_
  echo %date_% %time_% %attr_% %rightJustifiedSize_% %fullname_% >>%MYTEMP%\whereis.$$$
Goto :EOF

::==================================================================
:FuncRightJustify arg1 arg2
setlocal enableextensions
  set number_=            %1
  set number_=%number_:~-12%
endlocal & set "%2=%number_%" & Goto :EOF
